#include "helpers.h"

static unsigned int level_to_port_mapping[4] = {PD1, PD2, PD3, PD4};

void init_timer(void)
{
	OCR1A = 625;
	TIMSK1 = (1 << OCIE1A);
	TCCR1B = (4 << CS10) | (1 << WGM12);
}

void init(void)
{
	sei();

	DDRA = 0xFF;
	DDRB = 0xFF;

	DDRD |= (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4);

	init_timer();
}

void reset(void)
{
	PORTA = 0x00;
	PORTB = 0x00;

	trun_off_all();
}

void turn_on_level(int level)
{
	PORTD |= (1 << level_to_port_mapping[level]);
}

void trun_on_all(void)
{
	for (int i = LEVEL1; i < LEVEL4; i++) {
		turn_on_level(i);
	}
}

void turn_off_level(int level)
{
	PORTD &= ~(1 << level_to_port_mapping[level]);
}

void trun_off_all(void)
{
	for (int i = LEVEL1; i < LEVEL4; i++) {
		turn_off_level(i);
	}
}
